'' RR20090917    _rr122 Use new fsrw23 routines (fsrw.spin & mb_rawb_spi.spin)
''                        modified to disable readahead and release SD pins after use
''                        fsrwFemto_rr001 for compatibility with new fsrw
''
''
''

CON

  baud          = 115_200                          


'USER CONFIGURATION OPTIONS

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

' microSD pins on TriBladeProp Blade #2                  
  spiDO         = 9
  spiClk        = 28
  spiDI         = 8
  spiCS         = 14



OBJ

  UART     : "FullDuplexSerial_rr004"                   'FDX v1.2 with mods
'  tbp2     : "TriBladeProp_Blade2_202"                  'Blade2 hardware driver
'#ifdef fsrw_new
  sd       : "fsrw_rr001"                               'SD access (latest from lonesock/rokicki)
'#else
'  sd       : "fsrwFemto_rr001"                          'SD Software used in FemtoBASIC
'#endif

CON


VAR     

  word err                      'Error code return value

'For microSD routines
  long  drive_base[18]          'SD base address of drives 0..15 (A:..L:) + boot code
  long  ioControl[2]            'SD parameters                     
  byte  buff[512]               'SD buffer




PUB start | i, j, n, r, fsize, st

  waitcnt(clkfreq*3 + cnt)      'delay (so you can get PropTerminal active)     <=== 3 secs


  'Start the terminal
  UART.start(31,30,0,baud)      'start the uart Tx and Rx and set the baud rate

  UART.str(string("Test fsrw on the TriBladeProp v0.122"))
  crlf

'------------------------------------------------------------------------------
' Locate the files on SD card and set their sector base addresses
'------------------------------------------------------------------------------

  r := sd.mount_explicit(spiDO,spiClk,spiDI,spiCS)      'mount the SD
  CheckError(r)


' locate the file "ZIBOOT   .COM" and set it's base address
  n := 17
  st := string("ZIBOOT  .COM")
  UART.tx($41 + n)
  UART.tx(":")                                          'A:...
  UART.str(st)

  r := sd.popen(st,"r")                                 'Open file for read
  CheckError(r)

'#ifdef fsrw_new
  drive_base[n] := sd.getSDdatablock                    'get the sectorno of the file (returns the sector+1)
  fsize := sd.get_filesize                              'get filesize
'#else
'  r := sd.pread(@buff,1)                                'get a char to find the sector address ****
'  CheckError(r)
'  drive_base[n] := ioControl[0] - 1                     'get the sectorno of the file (returns the sector+1)
'  fsize := -1                                           'set unknown size
'#endif

' display the sector base address
  uart.tx(" ")
  uart.dec(drive_base[n])
  uart.tx(" ")
  uart.dec(fsize)
  crlf

  r := sd.stopSDCard                                    'stop SD card, but do not stop cog
  CheckError(r)                                         '  calls sdspi.release

  UART.str(string("Loading SRAM... "))
  crlf

'  r := sd.initSDCard(spiDO,spiClk,spiDI,spiCS)          'init SD card, but do not restart cog
'  CheckError(r)
'  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ not required - should be automatic ??????????

  uart.str(string("read ZIBOOT.COM..."))
  crlf

'------------------------------------------------------------------------------
' fsrw (new version) FAILS TO RETURN FROM NEXT ROUTINE <========================================== 
'------------------------------------------------------------------------------
'read the ZIBOOT  .COM file (256 bytes)
  r := sd.readSDCard(drive_base[17], @buff, 256)        'get 256 bytes   "ZIBOOT  .COM"
  CheckError(r)                                         '  calls sdspi.readblock(address, bufAdr)
'  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ fails to return from sdspi.readblock

  uart.str(string("done..."))
  crlf

  r := sd.stopSDCard                                    'stop SD card, but do not stop cog
  CheckError(r)                                         '  calls sdspi.release

'DISPLAY THE DATA READ
  uart.str(string("data..."))
  crlf
  repeat j from 0 to 15
    repeat i from 0 to 15
      UART.hex(buff[(j*16)+i],2)
      UART.tx(" ")
    crlf
  crlf

'------------------------------------------------------------------------------
' Done - loop here
'------------------------------------------------------------------------------
  UART.str(string("Done... Stop."))
  crlf

  repeat  '<==================================
  

'==============================================================================
' TriBladeProp Routines
'==============================================================================

PRI CheckError(r)
  if r < 0
    UART.str(string("***Error*** $"))
    UART.hex(r,2)
    UART.str(string(" ***HALTED***"))
    crlf
    sd.stop
'    tbp2.stop
    repeat                                              '<==============  LOOP HERE

'==============================================================================

PRI DisplayError(errx)
  if errx
    UART.str(string(" ***Failed***"))
  else
    UART.str(string("Passed, please wait..."))
  crlf


PRI crlf
  UART.tx(13)
  UART.tx(10)
  